/**
 */
package com.qmetry.qaf.bdd.bddDsl.util;

import com.qmetry.qaf.bdd.bddDsl.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see com.qmetry.qaf.bdd.bddDsl.BddDslPackage
 * @generated
 */
public class BddDslAdapterFactory extends AdapterFactoryImpl
{
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static BddDslPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public BddDslAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = BddDslPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch that delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected BddDslSwitch<Adapter> modelSwitch =
    new BddDslSwitch<Adapter>()
    {
      @Override
      public Adapter caseNarrative(Narrative object)
      {
        return createNarrativeAdapter();
      }
      @Override
      public Adapter caseSCENARIO(SCENARIO object)
      {
        return createSCENARIOAdapter();
      }
      @Override
      public Adapter caseSTEP_DEF(STEP_DEF object)
      {
        return createSTEP_DEFAdapter();
      }
      @Override
      public Adapter caseStep(Step object)
      {
        return createStepAdapter();
      }
      @Override
      public Adapter caseStep2(Step2 object)
      {
        return createStep2Adapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link com.qmetry.qaf.bdd.bddDsl.Narrative <em>Narrative</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.qmetry.qaf.bdd.bddDsl.Narrative
   * @generated
   */
  public Adapter createNarrativeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.qmetry.qaf.bdd.bddDsl.SCENARIO <em>SCENARIO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.qmetry.qaf.bdd.bddDsl.SCENARIO
   * @generated
   */
  public Adapter createSCENARIOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.qmetry.qaf.bdd.bddDsl.STEP_DEF <em>STEP DEF</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.qmetry.qaf.bdd.bddDsl.STEP_DEF
   * @generated
   */
  public Adapter createSTEP_DEFAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.qmetry.qaf.bdd.bddDsl.Step <em>Step</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.qmetry.qaf.bdd.bddDsl.Step
   * @generated
   */
  public Adapter createStepAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.qmetry.qaf.bdd.bddDsl.Step2 <em>Step2</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.qmetry.qaf.bdd.bddDsl.Step2
   * @generated
   */
  public Adapter createStep2Adapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //BddDslAdapterFactory
