/*
 * generated by Xtext
 */
package com.qmetry.qaf.bdd.formatting;

import com.google.inject.Inject;
import org.eclipse.xtext.formatting.impl.AbstractDeclarativeFormatter;
import org.eclipse.xtext.formatting.impl.FormattingConfig;
import com.qmetry.qaf.bdd.services.BddDslGrammarAccess;

/**
 * This class contains custom formatting declarations.
 * 
 * See
 * https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#formatting
 * on how and when to use it.
 * 
 * Also see {@link org.eclipse.xtext.xtext.XtextFormattingTokenSerializer} as an
 * example
 */
public class BddDslFormatter extends AbstractDeclarativeFormatter {

	@Inject
	private BddDslGrammarAccess grammarAccess;

	@Override
	protected void configureFormatting(FormattingConfig c) {
		// It's usually a good idea to activate the following three statements.
		// They will add and preserve newlines around comments
		c.setLinewrap(0, 1, 2).before(grammarAccess.getSL_COMMENTRule());
		// c.setLinewrap(0, 1, 2).before(grammarAccess.getML_COMMENTRule());
		// c.setLinewrap(0, 1, 1).after(grammarAccess.getML_COMMENTRule());

		BddDslGrammarAccess g = (BddDslGrammarAccess) super.getGrammarAccess();
		c.setNoSpace().after(g.getSTEP_KEYWORDRule());
		c.setIndentationIncrement().before(g.getStepRule());
		c.setIndentationDecrement().after(g.getStepRule());
//		c.setIndentationIncrement().before(g.getStepDescriptionRule());
//		c.setIndentationDecrement().after(g.getStepDescriptionRule());
		c.setNoLinewrap().around(g.getStepDescriptionRule());
		c.setNoLinewrap().around(g.getNarrativeRule());
		c.setNoLinewrap().around(g.getTitleRule());
		c.setNoSpace().after(g.getTitleRule());
		c.setNoSpace().after(g.getStepDescriptionRule());
//		c.setNoSpace().after(g.getStepRule());
		c.setNoSpace().after(g.getENDRule());
		c.setNoSpace().after(g.getSCENARIORule());
		c.setNoSpace().after(g.getSTEP_DEFRule());
//		c.setIndentationIncrement().before(g.getStepRule());
//		c.setIndentationDecrement().after(g.getStepRule());
	}
}
