package com.qmetry.qaf.common;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.ui.JavaUI;
import org.eclipse.jface.text.IRegion;
import org.eclipse.jface.text.hyperlink.IHyperlink;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.PartInitException;

public class JavaHyperlink implements IHyperlink {

	private IJavaElement javaElement;
	private IRegion region;
	private String text;

	public JavaHyperlink(String text, IJavaElement javaElement, IRegion region) {
		super();
		this.javaElement = javaElement;
		this.region = region;
		this.text = text;
	}

	public String getHyperlinkText() {
		return text;
	}

	public IRegion getHyperlinkRegion() {
		return region;
	}

	public IJavaElement getElement() {
		return javaElement;
	}

	public String getTypeLabel() {
		return javaElement.getElementName();
	}

	public void open() {
		IEditorPart editorPart;
		try {
//			IResource resource = javaElement.getUnderlyingResource();
//			editorPart = IDE.openEditor(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage(), (IFile) resource, true);
			editorPart = JavaUI.openInEditor(javaElement);
			JavaUI.revealInEditor(editorPart, javaElement);
		} catch (PartInitException e) {
			e.printStackTrace();
		} catch (JavaModelException e) {
			e.printStackTrace();
		}
	}

}
