/*
 * generated by Xtext
 */
package com.qmetry.qaf.gherkin.validation;

import org.eclipse.jdt.core.IMethod;
import org.eclipse.xtext.validation.Check;

import com.google.inject.Inject;
import com.qmetry.qaf.gherkin.bddDsl.BddDslPackage;
import com.qmetry.qaf.gherkin.bddDsl.Step;
import com.qmetry.qaf.gherkin.validation.AbstractBddDslJavaValidator;
import com.qmetry.qaf.common.JavaStepHolder;

/**
 * This class contains custom validation rules.
 *
 * See
 * https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#validation
 */
public class BddDslJavaValidator extends AbstractBddDslJavaValidator {

	@Inject
	private JavaStepHolder matcher;

	@Check
	public void checkStepMatching(Step step) {
		final Counter counter = new Counter();
		String description = step.getDescription().trim();
		try {
			matcher.findMatches(description, counter);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (counter.get() == 0) {
			error("No definition found for `" + description + "`", BddDslPackage.Literals.STEP__DESCRIPTION);
		} /*
			 * else if (counter.get() > 1) {
			 * warning("Multiple definitions found for `" + description + "`",
			 * BddPackage.Literals.STEP__DESCRIPTION); }
			 */
	}

	private final static class Counter implements JavaStepHolder.Command {
		private int count = 0;

		public int get() {
			return count;
		}

		public void match(String annotationValue, IMethod method) {
			count++;
		}
	}
}
